---
# tasks file for restic-backup

- name: Ensure rclone is installed
  ansible.builtin.apt:
    name: rclone
    update_cache: yes
  become: true      

- name: Create rclone configuration folder.
  file:
    path: "{{ rclone_config_path }}"
    state: directory
    owner: root
    group: root
    mode: 0700


- name: Copy GCP service account key to the target server
  ansible.builtin.copy:
    src: "{{ local_gcp_service_account_key }}"
    dest: "{{ rclone_config_path }}/service_account_credentials.json"
    owner: root
    group: root
    mode: '0400'
  #delegate_to: localhost

- name: Configure rclone with GCP service account
  ansible.builtin.copy:
    dest: "{{ rclone_config_path }}/rclone.conf"
    content: |
      [google_drive]
      type = drive
      scope = drive
      root_folder_id = {{ folder_id }}
      service_account_file = {{ rclone_config_path }}/service_account_credentials.json
    owner: root
    group: root
    mode: '0600'


- name: Install Restic
  ansible.builtin.apt:
    name: restic
    update_cache: yes
  become: true  

- name: Create backup script
  ansible.builtin.template:
    src: "templates/gitlab_backup.j2"
    dest: "{{ backup_script_path }}"
    mode: '0750'

- name: Create passw file
  ansible.builtin.template:
    src: "templates/rclone_psw.j2"
    dest: "{{ rclone_config_path }}/rclone_psw"
    mode: '0600'    


- name: Schedule daily backup with retention policy
  ansible.builtin.cron:
    name: "GitLab backup"
    special_time: daily
    job: "{{ backup_script_path }} > /var/log/gitlab_backup.log 2>&1"
  become: true
